using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_QC_IndexBase
    /// </summary>
    public partial class T_QC_IndexBase
    {
        public T_QC_IndexBase()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_IndexId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_QC_IndexBase");
            strSql.Append(" where F_IndexId=@F_IndexId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_IndexId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_QC_IndexBase model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_QC_IndexBase(");
            strSql.Append("F_CategoryId,F_Type,F_Score,F_Title,F_Content,F_Remark,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag,F_SortModel,F_Sort)");
            strSql.Append(" values (");
            strSql.Append("@F_CategoryId,@F_Type,@F_Score,@F_Title,@F_Content,@F_Remark,@F_CreateOn,@F_CreateBy,@F_ModifyOn,@F_ModifyBy,@F_DeleteFlag,@F_SortModel,@F_Sort)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Float),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,1000),
                    new SqlParameter("@F_Content", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_Remark", SqlDbType.VarChar,500),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_SortModel", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_Type;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_Title;
            parameters[4].Value = model.F_Content;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_CreateOn;
            parameters[7].Value = model.F_CreateBy;
            parameters[8].Value = model.F_ModifyOn;
            parameters[9].Value = model.F_ModifyBy;
            parameters[10].Value = model.F_DeleteFlag;
            parameters[11].Value = model.F_SortModel;
            parameters[12].Value = model.F_Sort;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_QC_IndexBase model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_QC_IndexBase set ");
            strSql.Append("F_CategoryId=@F_CategoryId,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Score=@F_Score,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_ModifyOn=@F_ModifyOn,");
            strSql.Append("F_ModifyBy=@F_ModifyBy,");
            strSql.Append("F_DeleteFlag=@F_DeleteFlag,");
            strSql.Append("F_SortModel=@F_SortModel,");
            strSql.Append("F_Sort=@F_Sort");
            strSql.Append(" where F_IndexId=@F_IndexId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_CategoryId", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Score", SqlDbType.Float),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,1000),
                    new SqlParameter("@F_Content", SqlDbType.VarChar,2000),
                    new SqlParameter("@F_Remark", SqlDbType.VarChar,500),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_ModifyOn", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyBy", SqlDbType.Int,4),
                    new SqlParameter("@F_DeleteFlag", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_SortModel", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_CategoryId;
            parameters[1].Value = model.F_Type;
            parameters[2].Value = model.F_Score;
            parameters[3].Value = model.F_Title;
            parameters[4].Value = model.F_Content;
            parameters[5].Value = model.F_Remark;
            parameters[6].Value = model.F_CreateOn;
            parameters[7].Value = model.F_CreateBy;
            parameters[8].Value = model.F_ModifyOn;
            parameters[9].Value = model.F_ModifyBy;
            parameters[10].Value = model.F_DeleteFlag;
            parameters[11].Value = model.F_SortModel;
            parameters[12].Value = model.F_Sort;
            parameters[13].Value = model.F_IndexId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_IndexId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexBase ");
            strSql.Append(" where F_IndexId=@F_IndexId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_IndexId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IndexIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_QC_IndexBase ");
            strSql.Append(" where F_IndexId in (" + F_IndexIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_QC_IndexBase GetModel(int F_IndexId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from vw_QC_IndexBase ");
            strSql.Append(" where F_IndexId=@F_IndexId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_IndexId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_IndexId;

            Model.T_QC_IndexBase model = new Model.T_QC_IndexBase();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_IndexId"] != null && ds.Tables[0].Rows[0]["F_IndexId"].ToString() != "")
                {
                    model.F_IndexId = int.Parse(ds.Tables[0].Rows[0]["F_IndexId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CategoryId"] != null && ds.Tables[0].Rows[0]["F_CategoryId"].ToString() != "")
                {
                    model.F_CategoryId = int.Parse(ds.Tables[0].Rows[0]["F_CategoryId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Type"] != null && ds.Tables[0].Rows[0]["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(ds.Tables[0].Rows[0]["F_Type"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Score"] != null && ds.Tables[0].Rows[0]["F_Score"].ToString() != "")
                {
                    model.F_Score = double.Parse(ds.Tables[0].Rows[0]["F_Score"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Title"] != null && ds.Tables[0].Rows[0]["F_Title"].ToString() != "")
                {
                    model.F_Title = ds.Tables[0].Rows[0]["F_Title"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Content"] != null && ds.Tables[0].Rows[0]["F_Content"].ToString() != "")
                {
                    model.F_Content = ds.Tables[0].Rows[0]["F_Content"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Remark"] != null && ds.Tables[0].Rows[0]["F_Remark"].ToString() != "")
                {
                    model.F_Remark = ds.Tables[0].Rows[0]["F_Remark"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_CreateOn"] != null && ds.Tables[0].Rows[0]["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_CreateOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CreateBy"] != null && ds.Tables[0].Rows[0]["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(ds.Tables[0].Rows[0]["F_CreateBy"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ModifyOn"] != null && ds.Tables[0].Rows[0]["F_ModifyOn"].ToString() != "")
                {
                    model.F_ModifyOn = DateTime.Parse(ds.Tables[0].Rows[0]["F_ModifyOn"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ModifyBy"] != null && ds.Tables[0].Rows[0]["F_ModifyBy"].ToString() != "")
                {
                    model.F_ModifyBy = int.Parse(ds.Tables[0].Rows[0]["F_ModifyBy"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DeleteFlag"] != null && ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString() != "")
                {
                    model.F_DeleteFlag = int.Parse(ds.Tables[0].Rows[0]["F_DeleteFlag"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_SortModel"] != null && ds.Tables[0].Rows[0]["F_SortModel"].ToString() != "")
                {
                    model.F_SortModel = int.Parse(ds.Tables[0].Rows[0]["F_SortModel"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Sort"] != null && ds.Tables[0].Rows[0]["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(ds.Tables[0].Rows[0]["F_Sort"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_CategoryName"] != null && ds.Tables[0].Rows[0]["F_CategoryName"].ToString() != "")
                {
                    model.F_CategoryName = ds.Tables[0].Rows[0]["F_CategoryName"].ToString();
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_IndexId,F_CategoryId,F_Type,F_Score,F_Title,F_Content,F_Remark,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag,F_SortModel,F_Sort ");
            strSql.Append(" FROM T_QC_IndexBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_IndexId,F_CategoryId,F_Type,F_Score,F_Title,F_Content,F_Remark,F_CreateOn,F_CreateBy,F_ModifyOn,F_ModifyBy,F_DeleteFlag,F_SortModel,F_Sort ");
            strSql.Append(" FROM T_QC_IndexBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_QC_IndexBase ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_IndexId desc");
            }
            strSql.Append(")AS Row, T.*  from T_QC_IndexBase T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}
